import 'windi.css'
import './styles/main.css'
import { ViteSSG } from 'vite-ssg'
import ElementPlus from 'element-plus'
import generatedRoutes from 'pages-generated'
import { setupLayouts } from 'layouts-generated'
import App from './App.vue'

import 'element-plus/lib/theme-chalk/index.css'

const routes = setupLayouts(generatedRoutes)

// https://github.com/antfu/vite-ssg
export const createApp = ViteSSG(
  App,
  { routes },
  (ctx) => {
    // install all modules under `modules/`
    Object.values(import.meta.globEager('./modules/*.ts')).map(i => i.install?.(ctx))
    ctx.app.use(ElementPlus)
  },
)
